/***************************************************************************
 *cr
 *cr            (C) Copyright 2007 The Board of Trustees of the
 *cr                        University of Illinois
 *cr                         All Rights Reserved
 *cr
 ***************************************************************************/

/* Size of the benchmark problem.  The GPU can run larger problems in a
 * reasonable time.
 *
 * For VOLSIZEX, VOLSIZEY, size 1024 is suitable for a few seconds of
 * GPU computation and size 128 is suitable for a few seconds of
 * CPU computation.
 *
 * For ATOMCOUNT, 100000 is suitable for GPU computation and 10000 is
 * suitable for CPU computation.
 */
#define VOLSIZEX 512
#define VOLSIZEY 512
#define ATOMCOUNT 20000

#include <parboil.h>

typedef struct {
  int x;
  int y;
  int z;
} voldim3i;

#ifndef __CUDACC__
typedef struct _tag {
  float x;
  float y;
  float z;
  float w;
} float4;
#endif

#ifdef __cplusplus
extern "C" {
#endif

/* The main compute kernel. */
void calc_energy(
	  float *energygrid,
    voldim3i grid,
	  const float *atoms,
	  int numatoms,
	  float gridspacing,
	  float k,
    struct pb_TimerSet* timers);

#ifdef __cplusplus
};
#endif

